This service will be undergoing maintenance at 00:00 UTC, 2016-09-28. It is expected to last about 1 hours
Bug 243908 - nanny blocks SIGALRM causing tftp client timeout not to be handled.
nanny blocks SIGALRM causing tftp client timeout not to be handled.
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: piranha (Show other bugs)
5.0
All Linux
low Severity medium
: ---
: ---
Assigned To: Lon Hohberger
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2007-06-12 13:35 EDT by Jeff Bearer
Modified: 2009-04-16 18:55 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-01-20 15:54:42 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)
Fix: unblock all signals + return to default handler after fork (738 bytes, patch)
2007-06-15 14:38 EDT, Lon Hohberger
no flags Details | Diff
Patch for rhel5 (1.73 KB, patch)
2007-06-15 14:45 EDT, Lon Hohberger
no flags Details | Diff

  None (edit)
Description Jeff Bearer 2007-06-12 13:35:56 EDT
Description of problem:

Nanny is blocking SIGALRM and some other process signals.  I'm trying to monitor
 tftp and the tftp client times out with a SIGALRM, thus leaving the tftp
process to hang around forever never going away.

The tftp client never terminates, nanny never gets a bad status and never
removes the server from the cluster.

Version-Release number of selected component (if applicable):


How reproducible:

Every Time

Steps to Reproduce:
1. Configure Piranha to use this nagios check_tftp plugin:
http://mathias-kettner.de/download/check_tftp
2. Stop xinetd and in.tftpd on the server
3. Watch the tftp process hang forever.

lvs.cf
expect = "OK - answer from server"
use_regex = 0
send_program = "/usr/local/bin/check_tftp --connect %h"

Actual results:
# date
Tue Jun 12 13:35:32 EDT 2007

root     13206  ... Ts   12:19   0:00 /usr/sbin/nanny -c -h 10.0.0.4 -p 69 -f 1
-u -e /usr/local/bin/check_tftp --connect %h -x OK - answer from server -q -a 15
-I /sbin/ipvsadm -t 6 -w 1 -V 10.98.200.114 -M g -U none --lvs
root     17482  ... S    12:19   0:00 tftp 10.0.0.4
root     17483  ... S    12:19   0:00 head -n 1

Expected results:

tftp to actually terminate, and the check_tftp script to return an error output
for nanny to parse.

Additional info:
Comment 1 Lon Hohberger 2007-06-15 14:38:57 EDT
Created attachment 157141 [details]
Fix: unblock all signals + return to default handler after fork
Comment 2 Lon Hohberger 2007-06-15 14:45:33 EDT
Created attachment 157142 [details]
Patch for rhel5

(replacing old patch which was for rhel4)
Comment 3 Lon Hohberger 2007-06-15 14:46:02 EDT
Patches in CVS
Comment 4 Lon Hohberger 2007-06-15 14:48:44 EDT
(Note; this patch depends on the previous patch in cvs)

Tarball is here for interested parties:

http://people.redhat.com/lhh/piranha-0.8.6.2.tar.gz
Comment 5 RHEL Product and Program Management 2007-10-15 23:57:48 EDT
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.
Comment 6 Jay Turner 2007-11-30 02:26:47 EST
QE ack for RHEL5.2.  Reproducer in comment 0.
Comment 14 errata-xmlrpc 2009-01-20 15:54:42 EST
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2009-0095.html

Note You need to log in before you can comment on or make changes to this bug.